#include "game.h"

int globalMusicVolume=128;

Game::Game() {
	this->symbols.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/symbol1.png"));
	this->symbols.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/symbol2.png"));
	this->symbols.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/symbol3.png"));
	this->symbols.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/symbol4.png"));
	this->symbols.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/symbol5.png"));

	this->background.load(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/mainscreen.png");
	this->symbols[0]->blit(this->background.getSDLSurface(),getScreenCoordinate(297),getScreenCoordinate(110));
	this->symbols[1]->blit(this->background.getSDLSurface(),getScreenCoordinate(297),getScreenCoordinate(110+TILEHEIGHT+1));
	this->symbols[2]->blit(this->background.getSDLSurface(),getScreenCoordinate(297),getScreenCoordinate(110+(2*(TILEHEIGHT+1))));
	this->symbols[3]->blit(this->background.getSDLSurface(),getScreenCoordinate(297),getScreenCoordinate(110+(3*(TILEHEIGHT+1))));
	this->symbols[4]->blit(this->background.getSDLSurface(),getScreenCoordinate(297),getScreenCoordinate(110+(4*(TILEHEIGHT+1))));
	SDL_Rect r;
	r.x=getScreenCoordinate(243);
	r.y=getScreenCoordinate(22);
	r.w=getScreenCoordinate(70);
	r.h=getScreenCoordinate(14);
	SDL_FillRect(background.getSDLSurface(),&r,0);
	r.x=getScreenCoordinate(5);
	r.y=getScreenCoordinate(5);
	r.w=getScreenCoordinate(11*TILEWIDTH+10);
	r.h=getScreenCoordinate(11*TILEHEIGHT+10);
	SDL_FillRect(background.getSDLSurface(),&r,0);
	r.x=getScreenCoordinate(279);
	r.y=getScreenCoordinate(110);
	r.w=getScreenCoordinate(12);
	r.h=getScreenCoordinate(104);
	SDL_FillRect(background.getSDLSurface(),&r,0);

	this->symbolExit.load(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/exit.png");
	this->timer.load(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/timer.png");
	this->messageBG.load(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/messagebackground.png");
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0001.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0002.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0003.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0004.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0005.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0006.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0007.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0008.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0009.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0010.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0011.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0012.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0013.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0014.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0015.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0016.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0017.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0018.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0019.png",0));
	this->player.push_back(new Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/player0020.png",0));
}

Uint32 Game::getScore(int level, int severity) {
	int tmpscore;
	if (severity>0) {
		tmpscore=(level/severity)>>2;
		if (tmpscore<1) {
			tmpscore=1;
		}
		return tmpscore;
	}
	return 0;
}

Uint32 Game::run(int severity) {
	SDL_Surface *screen=SDL_GetVideoSurface();
	SDL_Event event;
	SDLTTF ttf(SHAREDIR"/"FONT,getSmallFontSize());
	SDLTTF bigText(SHAREDIR"/"FONT,getBigFontSize());
	SDL_Rect blackRect;

	int done=0;
	int levelx=5;
	int levely=5;
	int playerFrame=0;
	int playerAnimDir=0;
	int actualLevel=0;
	int timeBonus=severity;

	Level level;
	level.load(actualLevel, severity);
	int playerX=level.getStartX();
	int playerY=level.getStartY();
	int playerNextX=playerX;
	int playerNextY=playerY;
	int gameFinished=0;

	int animOffsetX=0;
	int animOffsetY=0;

	int keyUp=0;
	int keyDown=0;
	int keyLeft=0;
	int keyRight=0;
	int keyVolDown=0;
	int keyVolUp=0;
	Uint32 score=0;

	int isMoving=0;
	int playerDied=0;
	int hidePlayer=0;
	int dieAnim=0;
	int dieAnimStep=0;

	int timeout=0;
	int blinkDir=0;
	int color=0x60;
	int blinkCounter=0;
	int maxLives=3;
	int lives=maxLives;
	int offset;
	int delayVal;

	blackRect.w=getScreenCoordinate(TILEWIDTH);
	blackRect.h=getScreenCoordinate(TILEHEIGHT);

	Uint32 lastTicks=SDL_GetTicks();
	Uint32 levelStartTicks=SDL_GetTicks();
	Uint32 secondsSinceStart=0;

	Music music(randomMusic->getFileName());
	music.setVolume(globalMusicVolume);
	music.rewind();
	music.playOnce();

	Sample smpJump=Sample(SHAREDIR"/data/jump.wav");
	smpJump.setVolume(globalMusicVolume);

	while (!done) {
		if (!Mix_PlayingMusic()) {
			music.load(randomMusic->getFileName());
			while (!music.loaded) {
				music.load(randomMusic->getFileName());
			}
			music.rewind();
			music.playOnce();
		}
		while (SDL_PollEvent (&event)) {
			switch (event.type) {
				case SDL_KEYDOWN:
				case SDL_JOYBUTTONDOWN:
					if (
							( (event.key.keysym.sym == SDLK_c) && (event.key.keysym.mod & (KMOD_LCTRL | KMOD_RCTRL)) ) ||
							(event.key.keysym.sym == SDLK_ESCAPE) ||
							( event.jbutton.button == VK_SELECT )
					   ) {
						done = 1;
					}
					if (
							(event.key.keysym.sym == SDLK_1) ||
							(event.jbutton.button == VK_VOL_DOWN)
					   ) {
						keyVolDown=1;
					}
					if (
							(event.key.keysym.sym == SDLK_2) ||
							(event.jbutton.button == VK_VOL_UP)
					   ) {
						keyVolUp=1;
					}
					if (
							(event.key.keysym.sym==SDLK_UP) ||
							(event.jbutton.button == VK_UP)
					   ) {
						keyUp=1;
						keyDown=0;
						keyLeft=0;
						keyRight=0;
					}
					if (
							(event.key.keysym.sym==SDLK_RIGHT) ||
							(event.jbutton.button == VK_RIGHT)
					   ) {
						keyUp=0;
						keyDown=0;
						keyLeft=0;
						keyRight=1;
					}
					if (
							(event.key.keysym.sym==SDLK_LEFT) ||
							(event.jbutton.button == VK_LEFT)
					   ) {
						keyUp=0;
						keyDown=0;
						keyLeft=1;
						keyRight=0;
					}
					if (
							(event.key.keysym.sym==SDLK_DOWN) ||
							(event.jbutton.button == VK_DOWN)
					   ) {
						keyUp=0;
						keyDown=1;
						keyLeft=0;
						keyRight=0;
					}
					break;
				case SDL_KEYUP:
				case SDL_JOYBUTTONUP:
					if (
							(event.key.keysym.sym==SDLK_UP) ||
							(event.jbutton.button == VK_UP)
					   ) {
						keyUp=0;
					}
					if (
							(event.key.keysym.sym==SDLK_RIGHT) ||
							(event.jbutton.button == VK_RIGHT)
					   ) {
						keyRight=0;
					}
					if (
							(event.key.keysym.sym==SDLK_LEFT) ||
							(event.jbutton.button == VK_LEFT)
					   ) {
						keyLeft=0;
					}
					if (
							(event.key.keysym.sym==SDLK_DOWN) ||
							(event.jbutton.button == VK_DOWN)
					   ) {
						keyDown=0;
					}
					if (
							(event.key.keysym.sym == SDLK_1) ||
							(event.jbutton.button == VK_VOL_DOWN)
					   ) {
						keyVolDown=0;
					}
					if (
							(event.key.keysym.sym == SDLK_2) ||
							(event.jbutton.button == VK_VOL_UP)
					   ) {
						keyVolUp=0;
					}
					break;
				case SDL_QUIT:
					done = 1;
					break;
				default:
					break;
			}
		}

		if (keyVolDown) {
			globalMusicVolume--;
			if (globalMusicVolume<0) globalMusicVolume=0;
			setGlobalVolume(globalMusicVolume);
			smpJump.setVolume(globalMusicVolume);
		}
		if (keyVolUp) {
			globalMusicVolume++;
			if (globalMusicVolume>128) globalMusicVolume=128;
			setGlobalVolume(globalMusicVolume);
			smpJump.setVolume(globalMusicVolume);
		}

		sdlLock(screen);
		this->background.blit(screen,0,0);
		for (int y=0;y<11;y++) {
			for (int x=0;x<11;x++) {
				if ( (level.data[y][x]>0) && (level.data[y][x]<6) ) {
					this->symbols[level.data[y][x]-1]->blit(screen,getScreenCoordinate(levelx+x*(TILEWIDTH+1)),getScreenCoordinate(levely+y*(TILEHEIGHT+1)));
				} else {
					if (level.data[y][x]==SYMBOL_EXIT) {
						this->symbolExit.blit(screen,getScreenCoordinate(levelx+x*(TILEWIDTH+1)),getScreenCoordinate(levely+y*(TILEHEIGHT+1)));
					}
				}
			}
		}
		if (!hidePlayer) this->player[playerFrame]->blit(screen,getScreenCoordinate(levelx+playerX*(TILEWIDTH+1)+animOffsetX),getScreenCoordinate(levely+playerY*(TILEHEIGHT+1)+animOffsetY));
		if (
				(playerDied) &&
				(hidePlayer)
		) {
			for (int y=0;y<11;y++) {
				for (int x=0;x<11;x++) {
					if (dieAnimStep==0) {
						if (y*11+x>dieAnim) {
							x=11;
							y=11;
						} else {
							this->symbols[2]->blit(screen,getScreenCoordinate(levelx+x*(TILEWIDTH+1)),getScreenCoordinate(levely+y*(TILEHEIGHT+1)));
						}
					} else {
						if (y*11+x>dieAnim) {
							this->symbols[2]->blit(screen,getScreenCoordinate(levelx+x*(TILEWIDTH+1)),getScreenCoordinate(levely+y*(TILEHEIGHT+1)));
						} else {
							blackRect.x=getScreenCoordinate(levelx+x*(TILEWIDTH+1));
							blackRect.y=getScreenCoordinate(levely+y*(TILEHEIGHT+1));

							SDL_FillRect(screen,&blackRect,0);
						}
					}

				}
			}
			if (timeout) {
				bigText.setForegroundColor(color,color,color);
				this->messageBG.blit(screen,getScreenCoordinate(10),getScreenCoordinate(73));
				bigText.render(screen, "TIMEOUT",getScreenCoordinate(levelx+45),getScreenCoordinate(100));

				if (blinkDir) {
					color-=16;
					if (color<0x60) {
						blinkDir=0;
					}
				} else {
					color+=16;
					if (color>255) {
						color=255;
						blinkDir=1;
					}
				}
				blinkCounter++;
			}
			if (dieAnim>11*11) {
				dieAnim=0;
				dieAnimStep++;
			}
			dieAnim+=3;
			// reset level
			if (dieAnimStep>1) {
				animOffsetY=0;
				animOffsetX=0;
				dieAnim=0;
				dieAnimStep=0;
				playerDied=0;
				playerAnimDir=0;
				hidePlayer=0;
				level.clear();
				level.load(actualLevel, severity);
				playerX=level.getStartX();
				playerY=level.getStartY();
				playerNextX=playerX;
				playerNextY=playerY;
				levelStartTicks=SDL_GetTicks();
				secondsSinceStart=0;
				timeout=0;
				keyUp=0;
				keyDown=0;
				keyLeft=0;
				keyRight=0;
				isMoving=0;

				if (!gameFinished) lives--;
				if ( (lives<1) || (gameFinished) ) {
					blinkDir=0;
					color=0x60;
					blinkCounter=0;
					string bonus="";
					int bonusperlive=(actualLevel)*666;
					int bonusn=(lives)*bonusperlive;


					if ( (lives>0) && (severity>0) ) {
						score+=bonusn;

						bonus="x ";
						bonus+=intToString(bonusperlive);
						bonus+=" = ";
						bonus+=intToString(bonusn);
					}


					sdlClearEvents();
					while (!done) {
						if (SDL_PollEvent (&event)) {
							switch (event.type) {
								case SDL_KEYDOWN:
								case SDL_JOYBUTTONDOWN:
									if (
											(event.key.keysym.sym==SDLK_RETURN) ||
											(event.key.keysym.sym==SDLK_ESCAPE) ||
											(event.key.keysym.sym==SDLK_SPACE) ||
											(event.jbutton.button == VK_START) ||
											(event.jbutton.button == VK_FB) ||
											(event.jbutton.button == VK_FX)
									   ) {
										done=1;
									}
									break;
							}
						}
						bigText.setForegroundColor(color,color,color);
						this->messageBG.blit(screen,getScreenCoordinate(10),getScreenCoordinate(73));
						if (gameFinished) {
							bigText.render(screen, "FINISH",getScreenCoordinate(levelx+66),getScreenCoordinate(90));
							if ( (lives>0) && (severity>0) ) {
								for (int i=0;i<lives;i++) {
									this->player[0]->blit(screen,getScreenCoordinate(levelx+17+((maxLives-1)-i)*(TILEHEIGHT+1)),getScreenCoordinate(134));
								}
								ttf.setForegroundColor(255,255,255);
								ttf.render(screen, bonus.c_str(),getScreenCoordinate(levelx+87),getScreenCoordinate(137));
							}
						} else {
							bigText.render(screen, "GAME OVER",getScreenCoordinate(levelx+22),getScreenCoordinate(100));
						}
						string scoreString=intToString(score);
						ttf.setForegroundColor(255,255,255);
						ttf.render(screen,scoreString,getScreenCoordinate(244),getScreenCoordinate(22));
						SDL_Flip(screen);
						SDL_Delay(25);

						if (blinkDir) {
							color-=16;
							if (color<0x60) {
								blinkDir=0;
							}
						} else {
							color+=16;
							if (color>255) {
								color=255;
								blinkDir=1;
							}
						}
						blinkCounter++;
					}
					return score;
				}
			}
		}

		if ( (!playerDied) && (severity>0) ) secondsSinceStart=(SDL_GetTicks()-levelStartTicks)/1000;
		offset=(int)round((float)this->timer.getHeight()*(float)((float)secondsSinceStart/(float)level.getTimeout()));
		this->timer.blit(screen,getScreenCoordinate(279),getScreenCoordinate(110)+offset,0,(offset));

		for (int i=0;i<lives;i++) {
			this->player[0]->blit(screen,getScreenCoordinate(246),getScreenCoordinate(110+i*(TILEWIDTH+1)));
		}

		string scoreString=intToString(score);
		ttf.setForegroundColor(255,255,255);
		ttf.render(screen,scoreString,getScreenCoordinate(244),getScreenCoordinate(22));

		sdlUnlock(screen);
		SDL_Flip(screen);

		delayVal=SDL_GetTicks()-lastTicks;

		if ( (delayVal<30) && (delayVal>0) ) {
			SDL_Delay(30-delayVal);
		}
		lastTicks=SDL_GetTicks();

		if (playerAnimDir) {
			playerFrame--;
			if (playerFrame<0) {
				playerFrame=1;
				playerAnimDir=0;
			}
		} else {
			playerFrame++;
			if ((unsigned int)playerFrame>this->player.size()-1) {
				if ( 
						(!hidePlayer) &&
						(!playerDied)
				   ) {
					smpJump.play();
				}
				playerFrame=this->player.size()-2;
				playerAnimDir=1;
			}
		}

		if (playerDied) {
			hidePlayer=1;

			continue;
		}

		if (keyLeft) {
			if (!isMoving) {
				if (playerX>0) {
					isMoving++;
					animOffsetX=0;
					playerNextX=playerX-1;
				}
			}
		}
		if (keyRight) {
			if (!isMoving) {
				if (playerX<10) {
					isMoving++;
					animOffsetX=0;
					playerNextX=playerX+1;
				}
			}
		}
		if (keyUp) {
			if (!isMoving) {
				if (playerY>0) {
					isMoving++;
					animOffsetY=0;
					playerNextY=playerY-1;
				}
			}
		}
		if (keyDown) {
			if (!isMoving) {
				if (playerY<10) {
					isMoving++;
					animOffsetY=0;
					playerNextY=playerY+1;
				}
			}
		}

		if (playerNextX!=playerX) {
			if (
					(level.data[playerY][playerX]<6) &&
					(animOffsetX==0)
			) {
				level.data[playerY][playerX]--;
				score+=this->getScore(actualLevel,severity);
			}
			if (
					(animOffsetX<TILEWIDTH) &&
					(animOffsetX>-TILEWIDTH)
			) {
				animOffsetX+=(playerNextX-playerX)<<1;
			} else {
				playerX=playerNextX;
				animOffsetX=0;
				isMoving=0;
			}
		}
		if (playerNextY!=playerY) {
			if (
					(level.data[playerY][playerX]<6) &&
					(level.data[playerY][playerX]>0) &&
					(animOffsetY==0)
			) {
				level.data[playerY][playerX]--;
				score+=this->getScore(actualLevel,severity);
			}
			if (
					(animOffsetY<TILEHEIGHT) &&
					(animOffsetY>-TILEHEIGHT)
			) {
				animOffsetY+=(playerNextY-playerY)<<1;
			} else {
				playerY=playerNextY;
				animOffsetY=0;
				isMoving=0;
			}
		}
		if (!isMoving) {
			if (level.data[playerY][playerX]<1) {
				playerDied++;
				dieAnim=0;
				dieAnimStep=0;
			}
		}

		if (
			(level.isCleared()) &&
			(level.data[playerY][playerX]==SYMBOL_EXIT)
		) {
			score+=(this->timer.getHeight()-offset)*timeBonus;
			this->background.blit(screen,0,0);
			scoreString=intToString(score);
			ttf.setForegroundColor(255,255,255);
			ttf.render(screen,scoreString,getScreenCoordinate(244),getScreenCoordinate(22));
			level.clear();
			if (!level.load(++actualLevel, severity)) {
				playerDied++;
				dieAnim=0;
				dieAnimStep=0;
				hidePlayer=1;
				gameFinished=1;
			} else {
				playerX=level.getStartX();
				playerY=level.getStartY();
				playerNextX=playerX;
				playerNextY=playerY;
				levelStartTicks=SDL_GetTicks();
				secondsSinceStart=0;
				animOffsetY=0;
				animOffsetX=0;
				playerAnimDir=0;
				hidePlayer=0;
				keyUp=0;
				keyDown=0;
				keyLeft=0;
				keyRight=0;
				isMoving=0;

				blinkDir=0;
				color=0x60;
				blinkCounter=0;

				string timebonus;

				timebonus="Timebonus: ";
				timebonus+=intToString((this->timer.getHeight()-offset)*timeBonus);
				int tboffset=ttf.getStringWidth(timebonus)>>1;

				while (blinkCounter<60) {
					bigText.setForegroundColor(color,color,color);
					this->messageBG.blit(screen,getScreenCoordinate(10),getScreenCoordinate(73));
					bigText.render(screen, "CLEARED!",getScreenCoordinate(levelx+40),getScreenCoordinate(100));
					if (severity>0) {
						ttf.setForegroundColor(0xff,0xff,0xff);
						ttf.render(screen, timebonus.c_str(),getScreenCoordinate(levelx)+tboffset,getScreenCoordinate(137));
					}
					SDL_Flip(screen);
					SDL_Delay(25);

					if (blinkDir) {
						color-=16;
						if (color<0x60) {
							blinkDir=0;
						}
					} else {
						color+=16;
						if (color>255) {
							color=255;
							blinkDir=1;
						}
					}
					blinkCounter++;
				}
			}
		}

		if (secondsSinceStart>(Uint32)level.getTimeout()) {
			blinkDir=0;
			color=0x60;
			blinkCounter=0;
			timeout=1;
			playerDied++;
			dieAnim=0;
			dieAnimStep=0;
		}

	}
	music.stop();
	return score;
}
