#include <sample.h>

Sample::Sample() {
	this->loaded=0;
}

Sample::Sample(string filename) {
	this->loaded=0;
	this->load(filename);
}

Sample::~Sample() {
	if (this->loaded) {
		Mix_FreeChunk(this->sample);
	}
}

int Sample::load(string filename) {
	if (this->loaded) {
		Mix_FreeChunk(this->sample);
	}
	this->loaded=0;
	this->sample=Mix_LoadWAV(filename.c_str());
	if (this->sample!=NULL) this->loaded=1;
	return this->loaded;
}

void Sample::play(int loops) {
	Mix_PlayChannel(-1,this->sample,loops);
}

void Sample::playLooped() {
	Mix_PlayChannel(-1,this->sample,-1);
}

void Sample::setVolume(int volume) {
	Mix_VolumeChunk(this->sample, volume);
}
