#include "intro.h"

#define INTRO_FRAME_DELAY 25
#define INTRO_FRAMES 1000/INTRO_FRAME_DELAY
#define LOGO_SECONDS 2
#define TEXT_SECONDS 20

void introRenderText(SDL_Surface *screen, SDLTTF *ttf, int nextcolor) {
	ttf->setForegroundColor(nextcolor,nextcolor,nextcolor);
	ttf->render(screen, "Copyright (c) 1991-2007 Heiko Irrgang",0,getScreenCoordinate(90));
	ttf->render(screen, "Music are cover versions of C64 SID tunes by:",0,getScreenCoordinate(100)+ttf->getTextHeight());
	ttf->render(screen, "Mike Alsop, Ben Daglish,",getScreenCoordinate(20),getScreenCoordinate(100)+2*ttf->getTextHeight());
	ttf->render(screen, "Matt Gray/Steve Barrett, Jeroen Tel",getScreenCoordinate(20),getScreenCoordinate(100)+3*ttf->getTextHeight());
	ttf->render(screen, "Additional code: Christoph Frick",0,getScreenCoordinate(100)+5*ttf->getTextHeight());
	ttf->render(screen, "Additional level design:",0,getScreenCoordinate(100)+7*ttf->getTextHeight());
	ttf->render(screen, "here could be your name",getScreenCoordinate(20),getScreenCoordinate(100)+8*ttf->getTextHeight());
}

void playIntro() {
	SDL_Event event;
	SDLTTF ttf(SHAREDIR"/"FONT,getSmallFontSize());
	int done=0;
	Image logo=Image(SHAREDIR"/data/gfx/"+intToString(getSizeID())+"/logo.png");
	SDL_Surface *screen=SDL_GetVideoSurface();

	int logoOffset[INTRO_FRAMES*LOGO_SECONDS];
	int tmp;
	int delay;
	for (int i=0;i<INTRO_FRAMES*LOGO_SECONDS;i++) {
		tmp=screen->h-(((screen->h/(INTRO_FRAMES*LOGO_SECONDS))*i));
		logoOffset[i]=abs(((long)(cos((float)i/10)*tmp)));
	}

	Uint32 lastFrameStart=SDL_GetTicks();

	Uint32 frame=0;
	while (!done) {
		sdlLock(screen);
		SDL_FillRect(screen,NULL,0);
		logo.blit(screen,0,logoOffset[frame]);
		sdlUnlock(screen);
		SDL_Flip(screen);
		delay=25-(SDL_GetTicks()-lastFrameStart);
		if (delay>0) SDL_Delay(delay);
		lastFrameStart=SDL_GetTicks();
		frame++;
		if (frame>=INTRO_FRAMES*LOGO_SECONDS) done=1;
	}

	while (SDL_PollEvent(&event)) {
	}

	done=0;
	frame=0;
	float colorScale;
	int nextcolor;
	while (!done) {
		sdlLock(screen);
		SDL_FillRect(screen,NULL,0);
		logo.blit(screen,0,0);
		colorScale=(float)frame/(INTRO_FRAMES*TEXT_SECONDS/24);
		if (colorScale>1) {
			while (SDL_PollEvent (&event)) {
				switch (event.type) {
					case SDL_KEYDOWN:
					case SDL_JOYBUTTONDOWN:
						if (
								( (event.key.keysym.sym == SDLK_c) && (event.key.keysym.mod & (KMOD_LCTRL | KMOD_RCTRL)) ) ||
								(event.key.keysym.sym == SDLK_ESCAPE) ||
								(event.key.keysym.sym == SDLK_SPACE) ||
								(event.key.keysym.sym == SDLK_RETURN) ||
								( event.jbutton.button == VK_FB ) ||
								( event.jbutton.button == VK_TAT ) ||
								( event.jbutton.button == VK_START )
						   ) {
							done = 1;
						}
				}
			}
			nextcolor=255;
		} else {
			nextcolor=(int)((float)255*colorScale);
		}
		introRenderText(screen,&ttf,nextcolor);
		sdlUnlock(screen);
		SDL_Flip(screen);
		delay=25-(SDL_GetTicks()-lastFrameStart);
		if (delay>0) SDL_Delay(delay);
		lastFrameStart=SDL_GetTicks();
		frame++;
		if (frame>=INTRO_FRAMES*TEXT_SECONDS) done=1;
	}

	nextcolor=255;
	while (nextcolor!=0) {
		nextcolor-=10;
		if (nextcolor<0) nextcolor=0;
		sdlLock(screen);
		introRenderText(screen,&ttf,nextcolor);
		sdlUnlock(screen);
		SDL_Flip(screen);
		delay=25-(SDL_GetTicks()-lastFrameStart);
		if (delay>0) SDL_Delay(delay);
		lastFrameStart=SDL_GetTicks();
	}

	done=0;
	frame=INTRO_FRAMES*LOGO_SECONDS-1;
	while (!done) {
		sdlLock(screen);
		SDL_FillRect(screen,NULL,0);
		logo.blit(screen,0,logoOffset[frame]);
		sdlUnlock(screen);
		SDL_Flip(screen);
		delay=25-(SDL_GetTicks()-lastFrameStart);
		if (delay>0) SDL_Delay(delay);
		lastFrameStart=SDL_GetTicks();
		frame--;
		if (frame==0) done=1;
	}
	SDL_FillRect(screen,NULL,0);
	SDL_Flip(screen);

}
